#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const effect_1 = require("effect");
const Http = __importStar(require("@effect/platform/HttpClient"));
const NodeCommandExecutor = __importStar(require("@effect/platform-node/CommandExecutor"));
const NodeFileSystem = __importStar(require("@effect/platform-node/FileSystem"));
const environment_1 = require("./environment");
const git_client_1 = require("./git-client");
const jira_client_1 = require("./jira-client");
const cli_1 = require("./cli");
const mainLive = effect_1.Layer.merge(NodeFileSystem.layer
    .pipe(effect_1.Layer.provide(NodeCommandExecutor.layer))
    .pipe(effect_1.Layer.provide(git_client_1.GitClientLive)), environment_1.EnvironmentLive).pipe(effect_1.Layer.provideMerge(Http.client.layer.pipe(effect_1.Layer.provide(jira_client_1.JiraClientLive))));
effect_1.Effect.runPromise(effect_1.Effect.provide((0, effect_1.pipe)(effect_1.Effect.sync(() => process.argv.slice(2)), effect_1.Effect.flatMap(cli_1.cliEffect)), mainLive));
